/*  Programa:		MSList.cpp, creado en TC++ 3.0
    Autor:		Manass Jess Galindo Bello
			Universidad Tecnolgica de la Mixteca
			Huajuapan de Len, Oaxaca, Mxico
			e-mails:
			  - ic012183@ndikandi.utm.mx
			  - manases@tepasasdeveras.com
			  - CBoyF1@hotmail.com  <---- Para conversar por
						      el messenger


   Este es el mtodo de ordenamiento MergeSort pero aplicado a listas,
   utilizando memoria dinmica, lo que permite ordenar una gran cantidad
   de nmeros (siempre y cuando tengas espacio en tu HD).
   El programa consta de 6 funciones:
      - El main =)
      - Una funcin iterativa que genera una lista de mximo 10 nmeros
	(lo puedes cambiar en MAX) aleatorios en el rango 0 - (MAX^2)-1
      - Una funcin recursiva que muestra una lista en pantalla
      - Una funcin recursiva que libera la memoria dinmica
      - La funcin MS que es doblemente recursiva
      - Una funcin que hace la mezcla (de ah el nombre de mergesort)

   Espero que no tengas problemas para entenderle, este programa no est
   fcil, est facilote =D, jeje.
   Lo hice lo ms sencillo que pude para que no se te complique entenderle.
*/

#include  <stdio.h>
#include  <conio.h>
#include <stdlib.h>

#define MAX 10

struct lista
{
   int numero;
   struct lista *sig;
};
typedef struct lista LISTATYPE;
typedef LISTATYPE * LISTAPTR;

void CreaLista (LISTAPTR *);
void AVerLaLista (LISTAPTR);
void FreeLista (LISTAPTR *);
void MS (int, int, LISTAPTR *);
void mezcla (int, int, int, int, LISTAPTR *);

void main ()
{
   LISTAPTR inicio= NULL;

   clrscr();
   randomize();
   CreaLista(&inicio);
   printf("Nmeros generados aleatoriamente:\n");
   AVerLaLista(inicio);
   MS(0,MAX-1,&inicio);
   printf("\n\nNmeros ordenados:\n");
   AVerLaLista(inicio);
   FreeLista(&inicio);
   getch();
}

void CreaLista (LISTAPTR *inicio)
{
   int i;
   LISTAPTR nuevo, temp;

   for (i=0; i<MAX; i++)
      {
	 nuevo= (LISTAPTR) malloc(sizeof(LISTATYPE));
	 nuevo->sig= NULL;
	 nuevo->numero= random(MAX*MAX);

	 if (*inicio == NULL)
	    *inicio= nuevo;
	 else
	    {
	       temp= *inicio;
	       while (temp->sig != NULL)
		  temp= temp->sig;
	       temp->sig= nuevo;
	    }
      }
}

void AVerLaLista (LISTAPTR inicio)
{
   if (inicio != NULL)
      {
	 printf("%d ",inicio->numero);
	 AVerLaLista(inicio->sig);
      }
}

void FreeLista (LISTAPTR *inicio)
{
   LISTAPTR temp= *inicio;

   if (*inicio != NULL)
      {
	 FreeLista(&((*inicio)->sig));
	 free(temp);
      }
}

void MS (int ini, int fin, LISTAPTR *inicio)
{
   int m, m1;

   if (ini < fin)
      {
	 m= (ini+fin)/2;
	 m1= m+1;
	 MS(ini,m,&(*inicio));
	 MS(m1,fin,&(*inicio));
	 mezcla(ini,m,m1,fin,&(*inicio));
      }
}

void mezcla (int ini, int m, int m1, int fin, LISTAPTR *inicio)
{
   LISTAPTR ci, cj;
   int i, j, k= 0, kC[MAX];

   ci= cj= *inicio;
   for (i=k; i<ini; i++,ci=ci->sig);
   for (j=k; j<m1; j++ ,cj=cj->sig);
   kC[k]= k;

   while (i<=m || j<=fin)
      {
	 if (i > m)
	    {
	       kC[k]= cj->numero;
	       j++;
	       cj= cj->sig;
	    }
	 else
	    if (j > fin)
	       {
		  kC[k]= ci->numero;
		  i++;
		  ci= ci->sig;
	       }
	    else
	       if (ci->numero < cj->numero)
		  {
		     kC[k]= ci->numero;
		     i++;
		     ci= ci->sig;
		  }
	       else
		  {
		     kC[k]= cj->numero;
		     j++;
		     cj= cj->sig;
		  }
	 k++;
      }

   for (ci=*inicio,i=k-k; i<ini; i++,ci=ci->sig);
   for (k=0; i<=fin; i++, k++,ci=ci->sig)
      ci->numero= kC[k];
}